theory Scratch   imports  Main
                 keywords "Term" :: diag   begin

datatype LIST = NIL | CONS nat LIST

fun    height :: "LIST \<Rightarrow> nat"
where "height NIL        = 0             "
    | "height (CONS _ t) = Suc (height t)"

declare [[ML_source_trace]]

ML{* val NIL    = @{code NIL}
     val height = @{code height}
     val _      = height NIL     *}

ML{* Outer_Syntax.command @{command_keyword Term} 
      " \<langle>Term\<rangle> reads and prints an arbitrary HOL term "
      (Parse.term >> (Isar_Cmd.print_term o pair [])) *}

Term "height a + height b = height b + height a"

find_theorems
































consts c :: bool

typedef T = "{True, c}" by blast

definition "P = (\<forall> (x::T) y. x = y)"

defs c_bool_def: "c \<equiv> \<not>P"

lemma F: False
proof -
 have A: "c \<longleftrightarrow> P"
  using P_def Rep_T Rep_T_inject Abs_T_inject
 by(cases, force+)
 show ?thesis
 using A c_bool_def by blast
qed

end